;***************************************************************
;******
;***************************************************************
                ideal
                %crefref
                %noincl
                %nomacs
                p386

;		model	large
;               include "help.asi"
;               include "386.asi"
;               include "seg0.asi"
;               include "system.asi"



;###### CODE ###################################################
;               codeseg
        segment ASM_TEXT word public 'CODE'
                assume  cs:ASM_TEXT


;***************************************************************
;u32 memtop_88()
;***************************************************************
        global  _memtop_88:far
        proc    _memtop_88 far

;***************************************************************
                mov     ah,88h
                int     15h             ;ax=kbs above 1m
                jc      @@err
                test    ax,ax           ;Happens on big mem systems
                jz      @@err
                xor     dx,dx
                add     ax,400h         ;account for 1024 low kb
                adc     dx,0
                shld    dx,ax,10        ;multiply by 1024
                shl     ax,10           ;  (kbytes -> bytes)
                jmp     @@ret
@@err:
                xor     dx,dx
                xor     ax,ax
;***************************************************************
@@ret:
                retf
        endp    _memtop_88


;***************************************************************
;u32 memtop_e801()
;***************************************************************
        global  _memtop_e801:far
        proc    _memtop_e801 far

;***************************************************************
                push    cx bx
                mov     ax,0E801h
                int     15h
                jc      @@err
                test    dx,dx
                jz      @@less16m
                xor     ax,ax           ;ignore info on low 16M
                add     dx,100h         ;account for low 16M
                jmp     @@ret
@@less16m:                              ;dx=0 here, ax=kbs above 1m
                add     ax,400h         ;account for 1024 low kb
                shld    dx,ax,10        ;multiply by 1024
                shl     ax,10           ;  (kbytes -> bytes)
                jmp     @@ret
@@err:
                xor     dx,dx
                xor     ax,ax
;***************************************************************
@@ret:
                pop     bx cx
                retf
        endp    _memtop_e801

        ends    ASM_TEXT

        end

;###### END OF FILE ############################################
